#!/usr/bin/env python
# a bar plot with errorbars

import matplotlib
from matplotlib import mlab
matplotlib.use('Agg')
import matplotlib.pyplot
import matplotlib.pyplot as plt
from pylab import *
import sys
import MySQLdb
import signal
import numpy as numpie
import re
pre="./newplots/"
AUTOGRADER='AutoGrader'
SYGUS='Sygus'
#plots.getPlots(AUTOGRADER,'AG1')
k=10
perlist = [(i*1.0)/k for i in range(100*k+1)]
db = MySQLdb.connect(host="localhost", user="root", passwd="", db="results")
cur = db.cursor()
ag_mapping = dict()
sy_mapping = dict()

def get_stmt_same(bench,optimsource):
    if(optimsource == 'AG1' and bench == 'AutoGrader'):
        so_os_in= "('SO-AV-%d','SO-AV-%db')" % (83,83)
    elif(optimsource == 'AG2' and bench == 'AutoGrader'):
        so_os_in= "('SO-AV-%d','SO-AV-%db')" % (91,91)
    elif(optimsource == 'SY1' and bench == 'Sygus'):
        so_os_in= "('SO-SV-%d','SO-SV-%db')" % (5,5)
    elif(optimsource == 'SY2' and bench == 'Sygus'):
        so_os_in= "('SO-SV-%d','SO-SV-%db')" % (26,26)
    else:
        print "Invalid input to get_stmt_same"
        sys.exit(1)
    
    return "select cp.DagFile, cp.SolutionMedianTime cp_median, so.SolutionMedianTime so_median, do.SolutionMedianTime do_median, cp.SolutionAvgTime cp_avg, so.SolutionAvgTime so_avg, do.SolutionAvgTime do_avg,  cp.SolutionStDevTime cp_std, so.SolutionStDevTime so_std, do.SolutionStDevTime do_std, cp.SolutionAvgMaxMem cp_mem, so.SolutionAvgMaxMem so_mem, do.SolutionAvgMaxMem do_mem, cp.dagsize cp_sz, so.dagsize so_sz, do.dagsize do_sz from run_stats_cav16 cp, run_stats_cav16 do, run_stats_cav16 so where cp.dagfile = do.dagfile and cp.dagfile = so.dagfile and cp.optimsource ='CP' and do.optimsource = 'DO-L1' and so.benchmarkId = '" + bench+ "' and so.optimsource in " +so_os_in + " order by cp.DagFile asc"

def get_stmt_cross(bench,optimsource):
    main_so=dict()
    main_so[SYGUS] = 'SO-SY1-203%'
    main_so[AUTOGRADER] = 'SO-OT-299%'
    if(optimsource == 'AG1' and bench == SYGUS):
        so_os_like= 'SO-AG-F1'
    elif(optimsource == 'AG2' and bench == SYGUS):
        so_os_like= 'SO-AG-F2'
    elif(optimsource == 'SY1' and bench == AUTOGRADER):
        so_os_like= 'SO-SY-F1'
    else:
        print "Invalid input to get_stmt_cross"
        sys.exit(1)
    
    return "select cp.DagFile, cp.SolutionMedianTime cp_median, so.SolutionMedianTime so_median, do.SolutionMedianTime do_median, cp.SolutionAvgTime cp_avg, so.SolutionAvgTime so_avg, do.SolutionAvgTime do_avg,  cp.SolutionStDevTime cp_std, so.SolutionStDevTime so_std, do.SolutionStDevTime do_std, cp.SolutionAvgMaxMem cp_mem, so.SolutionAvgMaxMem so_mem, do.SolutionAvgMaxMem do_mem, cp.dagsize cp_sz, so.dagsize so_sz, do.dagsize do_sz from run_stats_vmcai cp, run_stats_vmcai do, run_stats_vmcai so where cp.dagfile = do.dagfile and cp.dagfile = so.dagfile and cp.optimsource ='CP' and do.optimsource like '"+main_so[bench]+"' and so.benchmarkId = '" + bench+ "' and so.optimsource like '" +so_os_like + "' order by cp.DagFile asc"
    
def get_ot_stmt(bench, run):
    if(bench == 'AutoGrader'):
        btab = 'AG_CV_C' + str(run)
    elif(bench == 'Sygus'):
        btab = 'SY_CV_C' + str(run)
    else:
        print "Invalid input to get_ot_stmt"
        sys.exit(1)
        
    if(bench==SYGUS):
        return  "select id,(100-metric) perf from " + btab + " where id > 0 order by id asc"
    else:
        return  "select (id-50) as id,(100-metric) perf from " + btab + " where id > 50 order by id asc"
    
def execute_smt(stmt):
    cur.execute(stmt)
    x = cur.fetchall()
    #assume that first element is key and the rest are in a list
    r = dict()
    for a in x:
        r[a[0]] = a[1:]
    return r

rewriters = ['AG1','AG2','SY1','SY2']
benches = [AUTOGRADER,SYGUS]

def parseSketchData(r):
    #return "select cp.DagFile, cp.SolutionMedianTime cp_median, so.SolutionMedianTime so_median, do.SolutionMedianTime do_median, cp.SolutionAvgTime cp_avg, so.SolutionAvgTime so_avg, do.SolutionAvgTime do_avg,  cp.SolutionStDevTime cp_std, so.SolutionStDevTime so_std, do.SolutionStDevTime do_std, cp.SolutionAvgMaxMem cp_mem, so.SolutionAvgMaxMem so_mem, do.SolutionAvgMaxMem do_mem from run_stats_vmcai cp, run_stats_vmcai do, run_stats_vmcai so where cp.dagfile = do.dagfile and cp.dagfile = so.dagfile and cp.optimsource ='CP' and do.optimsource = 'DO-L1' and so.benchmarkId = '" + bench+ "' and so.optimsource like '" +so_os_like + "'"
    res= dict() 
    res ["cp"] = dict()
    res ["so"] = dict()
    res ["do"] = dict()
    for optim in res:
        res[optim]["mean"] = []
        res[optim]["median"] = []
        res[optim]["stdev"] = []
        res[optim]["mem"] = []
        res[optim]["size"] = []
        
    for i in r:
        elt = r[i]
        res['cp']['median'].append(elt[0])
        res['so']['median'].append(elt[1])
        res['do']['median'].append(elt[2])
        res['cp']['mean'].append(elt[3])
        res['so']['mean'].append(elt[4])
        res['do']['mean'].append(elt[5])
        res['cp']['stdev'].append(elt[6])
        res['so']['stdev'].append(elt[7])
        res['do']['stdev'].append(elt[8])
        res['cp']['mem'].append(elt[9])
        res['so']['mem'].append(elt[10])
        res['do']['mem'].append(elt[11])
        res['cp']['size'].append(elt[12])
        res['so']['size'].append(elt[13])
        res['do']['size'].append(elt[14])
    return res

    
def getLabel(type):
    if(type=='median'):
        return "Median Time (in seconds)"
    elif type == "mean":
        return "Average Time (in seconds)"
    elif type == "mem":
        return "Average Maximum Memory Used (in MBs)"
    elif type == "size":
        return "Number of Terms in the problem DAG"
    else:
        print "Invalid type of graph: " + type
        cc()
        sys.exit(0)
def getPlot(bench,optimsource,data,type,N,otherbench):
    print bench,optimsource,len(data['so']),type,N
        
    config_num = int(re.sub("[^0-9]","",optimsource))
    fig = plt.figure(figsize=(8*(N/17.0),6))
    #plt.savefig('foo.png', bbox_inches='tight')
    ax = fig.add_subplot(111)
    #fig, ax = plt.subplots()
    ind = numpie.arange(N)
    #w = 0.35
    ## the bars
    margin = 0.15
    w = (1.-2.*margin)/3.0
    
    rects1 = ax.bar(ind+margin, data['cp'][type], width=w, color='red')
    rects2 = ax.bar(ind+margin+w, data['do'][type], width=w, color='yellow')
    rects3 = ax.bar(ind+margin+2*w, data['so'][type], width=w, color='green')
                   
    # rects2 = ax.bar(ind+w, data['so']['mean'], width,
                    # color='red',
                    # yerr=data['so']['stdev'],
                    # error_kw=dict(elinewidth=2,ecolor='black'))
    #ax.set_xlim(-2*w,len(ind)+w)
    #ax.set_ylim(0,45)
    ax.set_ylabel(getLabel(type))
    if(otherbench != bench):
        title = 'Performance of '+ otherbench +' rewriter on '+bench+' Benchmarks'
    else:
        title = 'Performance on '+bench+' Benchmarks: Configuration ' + str(config_num)
    
    ax.set_title(title)
    xTickMarks = [bench[0] + str(i+1) for i in range(N)]#['Group'+str(i) for i in range(1,6)]
    ax.set_xticks(ind+2*w)
    xtickNames = ax.set_xticklabels(xTickMarks)
    plt.setp(xtickNames, rotation=0, fontsize=11)

    ## add a legend
    if(bench == otherbench):
        ax.legend( (rects1[0], rects2[0], rects3[0]), ('Baseline','Hand-crafted', 'Auto-generated') )
    else:
        ax.legend( (rects1[0], rects2[0], rects3[0]), ('Baseline','Auto-generated for ' + bench, 'Auto-generated for ' + otherbench ) )
    plt.savefig(pre+bench + '_' + optimsource+ '_' + type + '.png', bbox_inches='tight')
    plt.close(fig)
 
def getPlotPerc(bench,optimsource,data,type,N,otherbench):
    print bench,optimsource,len(data['so']),type,N
        
    config_num = int(re.sub("[^0-9]","",optimsource))
    fig = plt.figure(figsize=(8,6))
    #plt.savefig('foo.png', bbox_inches='tight')
    ax = fig.add_subplot(111)
    #fig, ax = plt.subplots()
    ind = numpie.arange(N)
    #w = 0.35
    ## the bars
    margin = 0.15
    w = (1.-2.*margin)/3.0
    srtd=dict()
    perc=dict()
    lines=dict()
    col =dict()
    col['cp'] = 'red'
    col['do'] = 'blue'
    col['so'] = 'green'
    for i in ['cp','do','so']:
        srtd[i]=sorted(data[i][type])
        perc[i] = mlab.prctile(srtd[i], p=perlist)
        lines[i] = ax.plot(perlist,perc[i],'-',color=col[i]) 
    
    # rects1 = ax.bar(ind+margin, data['cp'][type], width=w, color='red')
    # rects2 = ax.bar(ind+margin+w, data['do'][type], width=w, color='yellow')
    # rects3 = ax.bar(ind+margin+2*w, data['so'][type], width=w, color='green')
                   
    # rects2 = ax.bar(ind+w, data['so']['mean'], width,
                    # color='red',
                    # yerr=data['so']['stdev'],
                    # error_kw=dict(elinewidth=2,ecolor='black'))
    #ax.set_xlim(-2*w,len(ind)+w)
    #ax.set_ylim(0,45)
    ax.set_ylabel(getLabel(type))
    ax.set_xlabel('Percentile')
    if(otherbench != bench):
        title = 'Performance of '+ otherbench +' simplifier on '+bench+' Benchmarks'
    else:
        title = 'Performance of Auto-generated simplifier on '+bench
    
    ax.set_title(title)
    #xTickMarks = [bench[0] + str(i+1) for i in range(N)]#['Group'+str(i) for i in range(1,6)]
    #ax.set_xticks(ind+2*w)
    #xtickNames = ax.set_xticklabels(xTickMarks)
    #plt.setp(xtickNames, rotation=0, fontsize=11)

    ## add a legend
    if(bench == otherbench):
        ax.legend( (lines['cp'][0], lines['do'][0], lines['so'][0]), ('Baseline','Hand-crafted', 'Auto-generated'), loc='upper left' )
    else:
        ax.legend( (lines['cp'][0], lines['do'][0], lines['so'][0]), ('Baseline','Auto-generated for ' + bench, 'Auto-generated for ' + otherbench ) , loc='upper left')
    plt.savefig(pre+bench + '_' + optimsource+ '_' + type + '.png', bbox_inches='tight')
    plt.close(fig)
    
 
def getLinePlots():
    for bench in [AUTOGRADER,SYGUS]:
        r=dict()
        for run in [1,2]: 
            r[run] = execute_smt(get_ot_stmt(bench,run))
        #print r
        #plot two lines graphs in one figure
        fig = plt.figure(figsize=(12,6))
        #ax = fig.add_subplot(111)
        
        plt.plot(r[1].keys(),r[1].values(),marker='o',linestyle='--',color='r',label="Configuration 1")
        plt.plot(r[2].keys(),r[2].values(),marker='s',linestyle='--',color='b',label="Configuration 2")
        plt.xlabel('Iteration')
        plt.ylabel('Optimization Function')
        plt.title('Auto-tuner: variation in value of Optimization Function: ' + bench)
        plt.legend(loc='lower right')
        plt.savefig(pre + bench + '_tuning.png', bbox_inches='tight')
        plt.close(fig)
def getPlots():
    #get 3 plots of CP,DO and SO-autogenerated versions with error bars on Mean time
    #Mean Time, Median Time, AvgMaxMem
    
    for bench in [AUTOGRADER,SYGUS]:
        for optimsource in ['AG1','AG2','SY1','SY2']:
            for type in ['median','mean','mem','size']:
                if(optimsource == 'SY2' and bench == AUTOGRADER):
                    continue
                if(re.sub("[0-9]","",optimsource) == 'AG'):
                    otherbench = AUTOGRADER
                elif (re.sub("[0-9]","",optimsource) == 'SY'):
                    otherbench = SYGUS
                else:
                    cc()
                    print "Invalid optimsource"
                    sys.exit(1)
                #print bench, optimsource
                if(bench == otherbench):
                    stmt = get_stmt_same(bench,optimsource)
                else:
                    stmt = get_stmt_cross(bench,optimsource)
                r = execute_smt(stmt)                
                #get data
                N = len(r)
                data = parseSketchData(r)
                #getPlot(bench,optimsource,data,type,N,otherbench)
                getPlotPerc(bench,optimsource,data,type,N,otherbench)
    
    #plt.show()

#select name, origNodeNum , rewrittenNodeNum  from rewritten_results_seis where name like '%ubuntu%';
def plot_smt():
    r = execute_smt('select name, origNodeNum , rewrittenNodeNum  from rewritten_results_seis where name like \'%ubuntu%\';')
    #r[name] = [orig,rewritten]
    data = dict()
    data[0] = []
    data[1] = []
    for name in r:
        for i in [0,1]:
            data[i].append(r[name][i])
        
    fig = plt.figure(figsize=(8,6))
    ax = fig.add_subplot(111)
    srtd=dict()
    perc=dict()
    lines=dict()
    col =dict()
    col[0] = 'red'
    col[1] = 'green'
    for i in [0,1]: #0 is orig, 1 is rewritten
        srtd[i]=sorted(data[i])
        perc[i] = mlab.prctile(srtd[i], p=perlist)
        lines[i] = ax.plot(perlist,perc[i],'-',color=col[i]) 
    
    # rects1 = ax.bar(ind+margin, data['cp'][type], width=w, color='red')
    # rects2 = ax.bar(ind+margin+w, data['do'][type], width=w, color='yellow')
    # rects3 = ax.bar(ind+margin+2*w, data['so'][type], width=w, color='green')
                   
    # rects2 = ax.bar(ind+w, data['so']['mean'], width,
                    # color='red',
                    # yerr=data['so']['stdev'],
                    # error_kw=dict(elinewidth=2,ecolor='black'))
    #ax.set_xlim(-2*w,len(ind)+w)
    #ax.set_ylim(0,45)
    ax.set_ylabel(getLabel('size'))
    ax.set_xlabel('Percentile')
    ax.set_title('Auto-generated simplifier on SMTLIB QF_LIA benchmarks')

    ## add a legend
    ax.legend( (lines[0][0], lines[1][0]), ('Baseline','Auto-generated for SMTLIB' ) , loc='upper left')
    plt.savefig(pre +'smt_size.png', bbox_inches='tight')
    plt.close(fig)
    
def cc():
    cur.close()
    db.close()
    
def signal_handler(signal, frame):
    print('You pressed Ctrl+C!')
    cc()
    sys.exit(0)
signal.signal(signal.SIGINT, signal_handler)
matplotlib.rcParams.update({'font.size': 12})

getLinePlots()
getPlots()
plot_smt()
cc()


